Index: inc/admin/lib.moduleslist.php
===================================================================
--- inc/admin/lib.moduleslist.php	(revision 3640)
+++ inc/admin/lib.moduleslist.php	(revision 3699)
@@ -1477,602 +1460,577 @@
 class adminThemesList extends adminModulesList
 {
-	/**
-	 * Constructor.
-	 *
-	 * Note that this creates dcStore instance.
-	 *
-	 * @param	object	$modules		dcModules instance
-	 * @param	string	$modules_root	Modules root directories
-	 * @param	string	$xml_url		URL of modules feed from repository
-	 */
-	public function __construct(dcModules $modules, $modules_root, $xml_url)
-	{
-		parent::__construct($modules, $modules_root, $xml_url);
-		$this->page_url = $this->core->adminurl->get('admin.blog.theme');
-	}
-
-	public function displayModules($cols=array('name', 'config', 'version', 'desc'), $actions=array(), $nav_limit=false)
-	{
-		echo
-		'<form action="'.$this->getURL().'" method="post" class="modules-form-actions">'.
-		'<div id="'.html::escapeHTML($this->list_id).'" class="modules'.(in_array('expander', $cols) ? ' expandable' : '').' one-box">';
-
-		$sort_field = $this->getSort();
-
-		# Sort modules by id
-		$modules = $this->getSearch() === null ?
-			self::sortModules($this->data, $sort_field, $this->sort_asc) :
-			$this->data;
-
-		$res = '';
-		$count = 0;
-		foreach ($modules as $id => $module)
-		{
-			# Show only requested modules
-			if ($nav_limit && $this->getSearch() === null) {
-				$char = substr($module[$sort_field], 0, 1);
-				if (!in_array($char, $this->nav_list)) {
-					$char = $this->nav_special;
-				}
-				if ($this->getIndex() != $char) {
-					continue;
-				}
-			}
-
-			$current = $this->core->blog->settings->system->theme == $id && $this->modules->moduleExists($id);
-			$distrib = self::isDistributedModule($id) ? ' dc-box' : '';
-
-			$line =
-			'<div class="box '.($current ? 'medium current-theme' : 'theme').$distrib.'">';
-
-			if (in_array('name', $cols) && !$current) {
-				$line .=
-				'<h4 class="module-name">';
-
-				if (in_array('checkbox', $cols)) {
-					$line .=
-					'<label for="'.html::escapeHTML($this->list_id).'_modules_'.html::escapeHTML($id).'">'.
-					form::checkbox(array('modules['.$count.']', html::escapeHTML($this->list_id).'_modules_'.html::escapeHTML($id)), html::escapeHTML($id)).
-					html::escapeHTML($module['name']).
-					'</label>';
-
-				}
-				else {
-					$line .=
-					form::hidden(array('modules['.$count.']'), html::escapeHTML($id)).
-					html::escapeHTML($module['name']);
-				}
-
-				$line .=
-				$this->core->formNonce().
-				'</h4>';
-			}
-
-			# Display score only for debug purpose
-			if (in_array('score', $cols) && $this->getSearch() !== null && defined('DC_DEBUG') && DC_DEBUG) {
-				$line .=
-				'<p class="module-score debug">'.sprintf(__('Score: %s'), $module['score']).'</p>';
-			}
-
-			if (in_array('sshot', $cols)) {
-				# Screenshot from url
-				if (preg_match('#^http(s)?://#', $module['sshot'])) {
-					$sshot = $module['sshot'];
-				}
-				# Screenshot from installed module
-				elseif (file_exists($this->core->blog->themes_path.'/'.$id.'/screenshot.jpg')) {
-					$sshot = $this->getURL('shot='.rawurlencode($id));
-				}
-				# Default screenshot
-				else {
-					$sshot = 'images/noscreenshot.png';
-				}
-
-				$line .=
-				'<div class="module-sshot"><img src="'.$sshot.'" alt="'.
-				sprintf(__('%s screenshot.'), html::escapeHTML($module['name'])).'" /></div>';
-			}
-
-			$line .=
-			'<div class="module-infos toggle-bloc">';
-
-			if (in_array('name', $cols) && $current) {
-				$line .=
-				'<h4 class="module-name">';
-
-				if (in_array('checkbox', $cols)) {
-					$line .=
-					'<label for="'.html::escapeHTML($this->list_id).'_modules_'.html::escapeHTML($id).'">'.
-					form::checkbox(array('modules['.$count.']', html::escapeHTML($this->list_id).'_modules_'.html::escapeHTML($id)), html::escapeHTML($id)).
-					html::escapeHTML($module['name']).
-					'</label>';
-				}
-				else {
-					$line .=
-					form::hidden(array('modules['.$count.']'), html::escapeHTML($id)).
-					html::escapeHTML($module['name']);
-				}
-
-				$line .=
-				'</h4>';
-			}
-
-			$line .=
-			'<p>';
-
-			if (in_array('desc', $cols)) {
-				$line .=
-				'<span class="module-desc">'.html::escapeHTML(__($module['desc'])).'</span> ';
-			}
-
-			if (in_array('author', $cols)) {
-				$line .=
-				'<span class="module-author">'.sprintf(__('by %s'),html::escapeHTML($module['author'])).'</span> ';
-			}
-
-			if (in_array('version', $cols)) {
-				$line .=
-				'<span class="module-version">'.sprintf(__('version %s'),html::escapeHTML($module['version'])).'</span> ';
-			}
-
-			if (in_array('current_version', $cols)) {
-				$line .=
-				'<span class="module-current-version">'.sprintf(__('(current version %s)'),html::escapeHTML($module['current_version'])).'</span> ';
-			}
-
-			if (in_array('parent', $cols) && !empty($module['parent'])) {
-				if ($this->modules->moduleExists($module['parent'])) {
-					$line .=
-					'<span class="module-parent-ok">'.sprintf(__('(built on "%s")'),html::escapeHTML($module['parent'])).'</span> ';
-				}
-				else {
-					$line .=
-					'<span class="module-parent-missing">'.sprintf(__('(requires "%s")'),html::escapeHTML($module['parent'])).'</span> ';
-				}
-			}
-
-			$has_details = in_array('details', $cols) && !empty($module['details']);
-			$has_support = in_array('support', $cols) && !empty($module['support']);
-			if ($has_details || $has_support) {
-				$line .=
-				'<span class="mod-more">';
-
-				if ($has_details) {
-					$line .=
-					'<a class="module-details" href="'.$module['details'].'">'.__('Details').'</a>';
-				}
-
-				if ($has_support) {
-					$line .=
-					' - <a class="module-support" href="'.$module['support'].'">'.__('Support').'</a>';
-				}
-
-				$line .=
-				'</span>';
-			}
-
-			$line .=
-			'</p>'.
-			'</div>';
-
-			$line .=
-			'<div class="module-actions toggle-bloc">';
-
-			# Plugins actions
-			if ($current) {
-
-				# _GET actions
-				if (file_exists(path::real($this->core->blog->themes_path.'/'.$id).'/style.css')) {
-					$theme_url = preg_match('#^http(s)?://#', $this->core->blog->settings->system->themes_url) ?
-						http::concatURL($this->core->blog->settings->system->themes_url, '/'.$id) :
-						http::concatURL($this->core->blog->url, $this->core->blog->settings->system->themes_url.'/'.$id);
-					$line .=
-					'<p><a href="'.$theme_url.'/style.css">'.__('View stylesheet').'</a></p>';
-				}
-
-				$line .= '<div class="current-actions">';
-
-				if (file_exists(path::real($this->core->blog->themes_path.'/'.$id).'/_config.php')) {
-					$line .=
-					'<p><a href="'.$this->getURL('module='.$id.'&amp;conf=1', false).'" class="button submit">'.__('Configure theme').'</a></p>';
-				}
-
-				# --BEHAVIOR-- adminCurrentThemeDetails
-				$line .=
-				$this->core->callBehavior('adminCurrentThemeDetails', $this->core, $id, $module);
-
-				$line .= '</div>';
-			}
-
-			# _POST actions
-			if (!empty($actions)) {
-				$line .=
-				'<p>'.implode(' ', $this->getActions($id, $module, $actions)).'</p>';
-			}
-
-			$line .=
-			'</div>';
-
-			$line .=
-			'</div>';
-
-			$count++;
-
-			$res = $current ? $line.$res : $res.$line;
-		}
-
-		echo
-		$res.
-		'</div>';
-
-		if(!$count && $this->getSearch() === null) {
-			echo
-			'<p class="message">'.__('No themes matched your search.').'</p>';
-		}
-
-		elseif ((in_array('checkbox', $cols) || $count > 1) && !empty($actions) && $this->core->auth->isSuperAdmin()) {
-			$buttons = $this->getGlobalActions($actions, in_array('checkbox', $cols));
-
-			if (!empty($buttons)) {
-				if (in_array('checkbox', $cols)) {
-					echo
-					'<p class="checkboxes-helpers"></p>';
-				}
-				echo '<div>'.implode(' ', $buttons).'</div>';
-			}
-		}
-
-		echo
-		'</form>';
-
-		return $this;
-	}
-
-	protected function getActions($id, $module, $actions)
-	{
-		$submits = array();
-
-		$this->core->blog->settings->addNamespace('system');
-		if ($id != $this->core->blog->settings->system->theme) {
-
-			# Select theme to use on curent blog
-			if (in_array('select', $actions)) {
-				$submits[] =
-				'<input type="submit" name="select['.html::escapeHTML($id).']" value="'.__('Use this one').'" />';
-			}
-		}
-
-		return array_merge(
-			$submits,
-			parent::getActions($id, $module, $actions)
-		);
-	}
-
-	protected function getGlobalActions($actions, $with_selection=false)
-	{
-		$submits = array();
-
-		foreach($actions as $action) {
-			switch($action) {
-
-				# Update (from store)
-				case 'update': if ($this->core->auth->isSuperAdmin() && $this->path_writable) {
-					$submits[] =
-					'<input type="submit" name="update" value="'.($with_selection ?
-						__('Update selected themes') :
-						__('Update all themes from this list')
-					).'" />'.$this->core->formNonce();
-				} break;
-
-				# Behavior
-				case 'behavior':
-
-					# --BEHAVIOR-- adminModulesListGetGlobalActions
-					$tmp = $this->core->callBehavior('adminModulesListGetGlobalActions', $this);
-
-					if (!empty($tmp)) {
-						$submits[] = $tmp;
-					}
-				break;
-			}
-		}
-
-		return $submits;
-	}
-
-	public function doActions()
-	{
-		if (empty($_POST) || !empty($_REQUEST['conf'])) {
-			return null;
-		}
-
-		$modules = !empty($_POST['modules']) && is_array($_POST['modules']) ? array_values($_POST['modules']) : array();
-
-		if (!empty($_POST['select'])) {
-
-			# Can select only one theme at a time!
-			if (is_array($_POST['select'])) {
-				$modules = array_keys($_POST['select']);
-				$id = $modules[0];
-
-				if (!$this->modules->moduleExists($id)) {
-					throw new Exception(__('No such theme.'));
-				}
-
-				$this->core->blog->settings->addNamespace('system');
-				$this->core->blog->settings->system->put('theme',$id);
-				$this->core->blog->triggerBlog();
-
-				dcPage::addSuccessNotice(__('Theme has been successfully selected.'));
-				http::redirect($this->getURL().'#themes');
-			}
-		}
-
-		else {
-			if (!$this->isWritablePath()) {
-				return null;
-			}
-
-			if ($this->core->auth->isSuperAdmin() && !empty($_POST['activate'])) {
-
-				if (is_array($_POST['activate'])) {
-					$modules = array_keys($_POST['activate']);
-				}
-
-				$list = $this->modules->getDisabledModules();
-				if (empty($list)) {
-					throw new Exception(__('No such theme.'));
-				}
-
-				$count = 0;
-				foreach($list as $id => $module) {
-
-					if (!in_array($id, $modules)) {
-						continue;
-					}
-
-					# --BEHAVIOR-- themeBeforeActivate
-					$this->core->callBehavior('themeBeforeActivate', $id);
-
-					$this->modules->activateModule($id);
-
-					# --BEHAVIOR-- themeAfterActivate
-					$this->core->callBehavior('themeAfterActivate', $id);
-
-					$count++;
-				}
-
-				dcPage::addSuccessNotice(
-					__('Theme has been successfully activated.', 'Themes have been successuflly activated.', $count)
-				);
-				http::redirect($this->getURL());
-			}
-
-			elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['deactivate'])) {
-
-				if (is_array($_POST['deactivate'])) {
-					$modules = array_keys($_POST['deactivate']);
-				}
-
-				$list = $this->modules->getModules();
-				if (empty($list)) {
-					throw new Exception(__('No such theme.'));
-				}
-
-				$failed = false;
-				$count = 0;
-				foreach($list as $id => $module) {
-
-					if (!in_array($id, $modules)) {
-						continue;
-					}
-
-					if (!$module['root_writable']) {
-						$failed = true;
-						continue;
-					}
-
-					$module[$id] = $id;
-
-					# --BEHAVIOR-- themeBeforeDeactivate
-					$this->core->callBehavior('themeBeforeDeactivate', $module);
-
-					$this->modules->deactivateModule($id);
-
-					# --BEHAVIOR-- themeAfterDeactivate
-					$this->core->callBehavior('themeAfterDeactivate', $module);
-
-					$count++;
-				}
-
-				if ($failed) {
-					dcPage::addWarningNotice(__('Some themes have not been deactivated.'));
-				}
-				else {
-					dcPage::addSuccessNotice(
-						__('Theme has been successfully deactivated.', 'Themes have been successuflly deactivated.', $count)
-					);
-				}
-				http::redirect($this->getURL());
-			}
-
-			elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['delete'])) {
-
-				if (is_array($_POST['delete'])) {
-					$modules = array_keys($_POST['delete']);
-				}
-
-				$list = $this->modules->getDisabledModules();
-
-				$failed = false;
-				$count = 0;
-				foreach($modules as $id)
-				{
-					if (!isset($list[$id])) {
-
-						if (!$this->modules->moduleExists($id)) {
-							throw new Exception(__('No such theme.'));
-						}
-
-						$module = $this->modules->getModules($id);
-						$module['id'] = $id;
-
-						if (!$this->isDeletablePath($module['root'])) {
-							$failed = true;
-							continue;
-						}
-
-						# --BEHAVIOR-- themeBeforeDelete
-						$this->core->callBehavior('themeBeforeDelete', $module);
-
-						$this->modules->deleteModule($id);
-
-						# --BEHAVIOR-- themeAfterDelete
-						$this->core->callBehavior('themeAfterDelete', $module);
-					}
-					else {
-						$this->modules->deleteModule($id, true);
-					}
-
-					$count++;
-				}
-
-				if (!$count && $failed) {
-					throw new Exception(__("You don't have permissions to delete this theme."));
-				}
-				elseif ($failed) {
-					dcPage::addWarningNotice(__('Some themes have not been delete.'));
-				}
-				else {
-					dcPage::addSuccessNotice(
-						__('Theme has been successfully deleted.', 'Themes have been successuflly deleted.', $count)
-					);
-				}
-				http::redirect($this->getURL());
-			}
-
-			elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['install'])) {
-
-				if (is_array($_POST['install'])) {
-					$modules = array_keys($_POST['install']);
-				}
-
-				$list = $this->store->get();
-
-				if (empty($list)) {
-					throw new Exception(__('No such theme.'));
-				}
-
-				$count = 0;
-				foreach($list as $id => $module) {
-
-					if (!in_array($id, $modules)) {
-						continue;
-					}
-
-					$dest = $this->getPath().'/'.basename($module['file']);
-
-					# --BEHAVIOR-- themeBeforeAdd
-					$this->core->callBehavior('themeBeforeAdd', $module);
-
-					$this->store->process($module['file'], $dest);
-
-					# --BEHAVIOR-- themeAfterAdd
-					$this->core->callBehavior('themeAfterAdd', $module);
-
-					$count++;
-				}
-
-				dcPage::addSuccessNotice(
-					__('Theme has been successfully installed.', 'Themes have been successuflly installed.', $count)
-				);
-				http::redirect($this->getURL());
-			}
-
-			elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['update'])) {
-
-				if (is_array($_POST['update'])) {
-					$modules = array_keys($_POST['update']);
-				}
-
-				$list = $this->store->get(true);
-				if (empty($list)) {
-					throw new Exception(__('No such theme.'));
-				}
-
-				$count = 0;
-				foreach($list as $module) {
-
-					if (!in_array($module['id'], $modules)) {
-						continue;
-					}
-
-					$dest = $module['root'].'/../'.basename($module['file']);
-
-					# --BEHAVIOR-- themeBeforeUpdate
-					$this->core->callBehavior('themeBeforeUpdate', $module);
-
-					$this->store->process($module['file'], $dest);
-
-					# --BEHAVIOR-- themeAfterUpdate
-					$this->core->callBehavior('themeAfterUpdate', $module);
-
-					$count++;
-				}
-
-				$tab = $count && $count == count($list) ? '#themes' : '#update';
-
-				dcPage::addSuccessNotice(
-					__('Theme has been successfully updated.', 'Themes have been successuflly updated.', $count)
-				);
-				http::redirect($this->getURL().$tab);
-			}
-
-			# Manual actions
-			elseif (!empty($_POST['upload_pkg']) && !empty($_FILES['pkg_file'])
-				|| !empty($_POST['fetch_pkg']) && !empty($_POST['pkg_url']))
-			{
-				if (empty($_POST['your_pwd']) || !$this->core->auth->checkPassword($_POST['your_pwd'])) {
-					throw new Exception(__('Password verification failed'));
-				}
-
-				if (!empty($_POST['upload_pkg'])) {
-					files::uploadStatus($_FILES['pkg_file']);
-
-					$dest = $this->getPath().'/'.$_FILES['pkg_file']['name'];
-					if (!move_uploaded_file($_FILES['pkg_file']['tmp_name'], $dest)) {
-						throw new Exception(__('Unable to move uploaded file.'));
-					}
-				}
-				else {
-					$url = urldecode($_POST['pkg_url']);
-					$dest = $this->getPath().'/'.basename($url);
-					$this->store->download($url, $dest);
-				}
-
-				# --BEHAVIOR-- themeBeforeAdd
-				$this->core->callBehavior('themeBeforeAdd', null);
-
-				$ret_code = $this->store->install($dest);
-
-				# --BEHAVIOR-- themeAfterAdd
-				$this->core->callBehavior('themeAfterAdd', null);
-
-				dcPage::addSuccessNotice($ret_code == 2 ?
-					__('Theme has been successfully updated.') :
-					__('Theme has been successfully installed.')
-				);
-				http::redirect($this->getURL().'#themes');
-			}
-
-			else {
-
-				# --BEHAVIOR-- adminModulesListDoActions
-				$this->core->callBehavior('adminModulesListDoActions', $this, $modules, 'theme');
-
-			}
-		}
-
-		return null;
-	}
+    /**
+     * Constructor.
+     *
+     * Note that this creates dcStore instance.
+     *
+     * @param    object    $modules        dcModules instance
+     * @param    string    $modules_root    Modules root directories
+     * @param    string    $xml_url        URL of modules feed from repository
+     */
+    public function __construct(dcModules $modules, $modules_root, $xml_url)
+    {
+        parent::__construct($modules, $modules_root, $xml_url);
+        $this->page_url = $this->core->adminurl->get('admin.blog.theme');
+    }
+
+    public function displayModules($cols = array('name', 'config', 'version', 'desc'), $actions = array(), $nav_limit = false)
+    {
+        echo
+        '<form action="' . $this->getURL() . '" method="post" class="modules-form-actions">' .
+        '<div id="' . html::escapeHTML($this->list_id) . '" class="modules' . (in_array('expander', $cols) ? ' expandable' : '') . ' one-box">';
+
+        $sort_field = $this->getSort();
+
+        # Sort modules by id
+        $modules = $this->getSearch() === null ?
+        self::sortModules($this->data, $sort_field, $this->sort_asc) :
+        $this->data;
+
+        $res   = '';
+        $count = 0;
+        foreach ($modules as $id => $module) {
+            # Show only requested modules
+            if ($nav_limit && $this->getSearch() === null) {
+                $char = substr($module[$sort_field], 0, 1);
+                if (!in_array($char, $this->nav_list)) {
+                    $char = $this->nav_special;
+                }
+                if ($this->getIndex() != $char) {
+                    continue;
+                }
+            }
+
+            $current = $this->core->blog->settings->system->theme == $id && $this->modules->moduleExists($id);
+            $distrib = self::isDistributedModule($id) ? ' dc-box' : '';
+
+            $line =
+                '<div class="box ' . ($current ? 'medium current-theme' : 'theme') . $distrib . '">';
+
+            if (in_array('name', $cols) && !$current) {
+                $line .=
+                    '<h4 class="module-name">';
+
+                if (in_array('checkbox', $cols)) {
+                    $line .=
+                    '<label for="' . html::escapeHTML($this->list_id) . '_modules_' . html::escapeHTML($id) . '">' .
+                    form::checkbox(array('modules[' . $count . ']', html::escapeHTML($this->list_id) . '_modules_' . html::escapeHTML($id)), html::escapeHTML($id)) .
+                    html::escapeHTML($module['name']) .
+                        '</label>';
+
+                } else {
+                    $line .=
+                    form::hidden(array('modules[' . $count . ']'), html::escapeHTML($id)) .
+                    html::escapeHTML($module['name']);
+                }
+
+                $line .=
+                $this->core->formNonce() .
+                    '</h4>';
+            }
+
+            # Display score only for debug purpose
+            if (in_array('score', $cols) && $this->getSearch() !== null && defined('DC_DEBUG') && DC_DEBUG) {
+                $line .=
+                '<p class="module-score debug">' . sprintf(__('Score: %s'), $module['score']) . '</p>';
+            }
+
+            if (in_array('sshot', $cols)) {
+                # Screenshot from url
+                if (preg_match('#^http(s)?://#', $module['sshot'])) {
+                    $sshot = $module['sshot'];
+                }
+                # Screenshot from installed module
+                elseif (file_exists($this->core->blog->themes_path . '/' . $id . '/screenshot.jpg')) {
+                    $sshot = $this->getURL('shot=' . rawurlencode($id));
+                }
+                # Default screenshot
+                else {
+                    $sshot = 'images/noscreenshot.png';
+                }
+
+                $line .=
+                '<div class="module-sshot"><img src="' . $sshot . '" alt="' .
+                sprintf(__('%s screenshot.'), html::escapeHTML($module['name'])) . '" /></div>';
+            }
+
+            $line .=
+                '<div class="module-infos toggle-bloc">';
+
+            if (in_array('name', $cols) && $current) {
+                $line .=
+                    '<h4 class="module-name">';
+
+                if (in_array('checkbox', $cols)) {
+                    $line .=
+                    '<label for="' . html::escapeHTML($this->list_id) . '_modules_' . html::escapeHTML($id) . '">' .
+                    form::checkbox(array('modules[' . $count . ']', html::escapeHTML($this->list_id) . '_modules_' . html::escapeHTML($id)), html::escapeHTML($id)) .
+                    html::escapeHTML($module['name']) .
+                        '</label>';
+                } else {
+                    $line .=
+                    form::hidden(array('modules[' . $count . ']'), html::escapeHTML($id)) .
+                    html::escapeHTML($module['name']);
+                }
+
+                $line .=
+                    '</h4>';
+            }
+
+            $line .=
+                '<p>';
+
+            if (in_array('desc', $cols)) {
+                $line .=
+                '<span class="module-desc">' . html::escapeHTML(__($module['desc'])) . '</span> ';
+            }
+
+            if (in_array('author', $cols)) {
+                $line .=
+                '<span class="module-author">' . sprintf(__('by %s'), html::escapeHTML($module['author'])) . '</span> ';
+            }
+
+            if (in_array('version', $cols)) {
+                $line .=
+                '<span class="module-version">' . sprintf(__('version %s'), html::escapeHTML($module['version'])) . '</span> ';
+            }
+
+            if (in_array('current_version', $cols)) {
+                $line .=
+                '<span class="module-current-version">' . sprintf(__('(current version %s)'), html::escapeHTML($module['current_version'])) . '</span> ';
+            }
+
+            if (in_array('parent', $cols) && !empty($module['parent'])) {
+                if ($this->modules->moduleExists($module['parent'])) {
+                    $line .=
+                    '<span class="module-parent-ok">' . sprintf(__('(built on "%s")'), html::escapeHTML($module['parent'])) . '</span> ';
+                } else {
+                    $line .=
+                    '<span class="module-parent-missing">' . sprintf(__('(requires "%s")'), html::escapeHTML($module['parent'])) . '</span> ';
+                }
+            }
+
+            $has_details = in_array('details', $cols) && !empty($module['details']);
+            $has_support = in_array('support', $cols) && !empty($module['support']);
+            if ($has_details || $has_support) {
+                $line .=
+                    '<span class="mod-more">';
+
+                if ($has_details) {
+                    $line .=
+                    '<a class="module-details" href="' . $module['details'] . '">' . __('Details') . '</a>';
+                }
+
+                if ($has_support) {
+                    $line .=
+                    ' - <a class="module-support" href="' . $module['support'] . '">' . __('Support') . '</a>';
+                }
+
+                $line .=
+                    '</span>';
+            }
+
+            $line .=
+                '</p>' .
+                '</div>';
+
+            $line .=
+                '<div class="module-actions toggle-bloc">';
+
+            # Plugins actions
+            if ($current) {
+
+                # _GET actions
+                if (file_exists(path::real($this->core->blog->themes_path . '/' . $id) . '/style.css')) {
+                    $theme_url = preg_match('#^http(s)?://#', $this->core->blog->settings->system->themes_url) ?
+                    http::concatURL($this->core->blog->settings->system->themes_url, '/' . $id) :
+                    http::concatURL($this->core->blog->url, $this->core->blog->settings->system->themes_url . '/' . $id);
+                    $line .=
+                    '<p><a href="' . $theme_url . '/style.css">' . __('View stylesheet') . '</a></p>';
+                }
+
+                $line .= '<div class="current-actions">';
+
+                if (file_exists(path::real($this->core->blog->themes_path . '/' . $id) . '/_config.php')) {
+                    $line .=
+                    '<p><a href="' . $this->getURL('module=' . $id . '&amp;conf=1', false) . '" class="button submit">' . __('Configure theme') . '</a></p>';
+                }
+
+                # --BEHAVIOR-- adminCurrentThemeDetails
+                $line .=
+                $this->core->callBehavior('adminCurrentThemeDetails', $this->core, $id, $module);
+
+                $line .= '</div>';
+            }
+
+            # _POST actions
+            if (!empty($actions)) {
+                $line .=
+                '<p>' . implode(' ', $this->getActions($id, $module, $actions)) . '</p>';
+            }
+
+            $line .=
+                '</div>';
+
+            $line .=
+                '</div>';
+
+            $count++;
+
+            $res = $current ? $line . $res : $res . $line;
+        }
+
+        echo
+            $res .
+            '</div>';
+
+        if (!$count && $this->getSearch() === null) {
+            echo
+            '<p class="message">' . __('No themes matched your search.') . '</p>';
+        } elseif ((in_array('checkbox', $cols) || $count > 1) && !empty($actions) && $this->core->auth->isSuperAdmin()) {
+            $buttons = $this->getGlobalActions($actions, in_array('checkbox', $cols));
+
+            if (!empty($buttons)) {
+                if (in_array('checkbox', $cols)) {
+                    echo
+                        '<p class="checkboxes-helpers"></p>';
+                }
+                echo '<div>' . implode(' ', $buttons) . '</div>';
+            }
+        }
+
+        echo
+            '</form>';
+
+        return $this;
+    }
+
+    protected function getActions($id, $module, $actions)
+    {
+        $submits = array();
+
+        $this->core->blog->settings->addNamespace('system');
+        if ($id != $this->core->blog->settings->system->theme) {
+
+            # Select theme to use on curent blog
+            if (in_array('select', $actions)) {
+                $submits[] =
+                '<input type="submit" name="select[' . html::escapeHTML($id) . ']" value="' . __('Use this one') . '" />';
+            }
+        }
+
+        return array_merge(
+            $submits,
+            parent::getActions($id, $module, $actions)
+        );
+    }
+
+    protected function getGlobalActions($actions, $with_selection = false)
+    {
+        $submits = array();
+
+        foreach ($actions as $action) {
+            switch ($action) {
+
+                # Update (from store)
+                case 'update':if ($this->core->auth->isSuperAdmin() && $this->path_writable) {
+                        $submits[] =
+                        '<input type="submit" name="update" value="' . ($with_selection ?
+                            __('Update selected themes') :
+                            __('Update all themes from this list')
+                        ) . '" />' . $this->core->formNonce();
+                    }break;
+
+                # Behavior
+                case 'behavior':
+
+                    # --BEHAVIOR-- adminModulesListGetGlobalActions
+                    $tmp = $this->core->callBehavior('adminModulesListGetGlobalActions', $this);
+
+                    if (!empty($tmp)) {
+                        $submits[] = $tmp;
+                    }
+                    break;
+            }
+        }
+
+        return $submits;
+    }
+
+    public function doActions()
+    {
+        if (empty($_POST) || !empty($_REQUEST['conf'])) {
+            return;
+        }
+
+        $modules = !empty($_POST['modules']) && is_array($_POST['modules']) ? array_values($_POST['modules']) : array();
+
+        if (!empty($_POST['select'])) {
+
+            # Can select only one theme at a time!
+            if (is_array($_POST['select'])) {
+                $modules = array_keys($_POST['select']);
+                $id      = $modules[0];
+
+                if (!$this->modules->moduleExists($id)) {
+                    throw new Exception(__('No such theme.'));
+                }
+
+                $this->core->blog->settings->addNamespace('system');
+                $this->core->blog->settings->system->put('theme', $id);
+                $this->core->blog->triggerBlog();
+
+                dcPage::addSuccessNotice(__('Theme has been successfully selected.'));
+                http::redirect($this->getURL() . '#themes');
+            }
+        } else {
+            if (!$this->isWritablePath()) {
+                return;
+            }
+
+            if ($this->core->auth->isSuperAdmin() && !empty($_POST['activate'])) {
+
+                if (is_array($_POST['activate'])) {
+                    $modules = array_keys($_POST['activate']);
+                }
+
+                $list = $this->modules->getDisabledModules();
+                if (empty($list)) {
+                    throw new Exception(__('No such theme.'));
+                }
+
+                $count = 0;
+                foreach ($list as $id => $module) {
+
+                    if (!in_array($id, $modules)) {
+                        continue;
+                    }
+
+                    # --BEHAVIOR-- themeBeforeActivate
+                    $this->core->callBehavior('themeBeforeActivate', $id);
+
+                    $this->modules->activateModule($id);
+
+                    # --BEHAVIOR-- themeAfterActivate
+                    $this->core->callBehavior('themeAfterActivate', $id);
+
+                    $count++;
+                }
+
+                dcPage::addSuccessNotice(
+                    __('Theme has been successfully activated.', 'Themes have been successuflly activated.', $count)
+                );
+                http::redirect($this->getURL());
+            } elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['deactivate'])) {
+
+                if (is_array($_POST['deactivate'])) {
+                    $modules = array_keys($_POST['deactivate']);
+                }
+
+                $list = $this->modules->getModules();
+                if (empty($list)) {
+                    throw new Exception(__('No such theme.'));
+                }
+
+                $failed = false;
+                $count  = 0;
+                foreach ($list as $id => $module) {
+
+                    if (!in_array($id, $modules)) {
+                        continue;
+                    }
+
+                    if (!$module['root_writable']) {
+                        $failed = true;
+                        continue;
+                    }
+
+                    $module[$id] = $id;
+
+                    # --BEHAVIOR-- themeBeforeDeactivate
+                    $this->core->callBehavior('themeBeforeDeactivate', $module);
+
+                    $this->modules->deactivateModule($id);
+
+                    # --BEHAVIOR-- themeAfterDeactivate
+                    $this->core->callBehavior('themeAfterDeactivate', $module);
+
+                    $count++;
+                }
+
+                if ($failed) {
+                    dcPage::addWarningNotice(__('Some themes have not been deactivated.'));
+                } else {
+                    dcPage::addSuccessNotice(
+                        __('Theme has been successfully deactivated.', 'Themes have been successuflly deactivated.', $count)
+                    );
+                }
+                http::redirect($this->getURL());
+            } elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['delete'])) {
+
+                if (is_array($_POST['delete'])) {
+                    $modules = array_keys($_POST['delete']);
+                }
+
+                $list = $this->modules->getDisabledModules();
+
+                $failed = false;
+                $count  = 0;
+                foreach ($modules as $id) {
+                    if (!isset($list[$id])) {
+
+                        if (!$this->modules->moduleExists($id)) {
+                            throw new Exception(__('No such theme.'));
+                        }
+
+                        $module       = $this->modules->getModules($id);
+                        $module['id'] = $id;
+
+                        if (!$this->isDeletablePath($module['root'])) {
+                            $failed = true;
+                            continue;
+                        }
+
+                        # --BEHAVIOR-- themeBeforeDelete
+                        $this->core->callBehavior('themeBeforeDelete', $module);
+
+                        $this->modules->deleteModule($id);
+
+                        # --BEHAVIOR-- themeAfterDelete
+                        $this->core->callBehavior('themeAfterDelete', $module);
+                    } else {
+                        $this->modules->deleteModule($id, true);
+                    }
+
+                    $count++;
+                }
+
+                if (!$count && $failed) {
+                    throw new Exception(__("You don't have permissions to delete this theme."));
+                } elseif ($failed) {
+                    dcPage::addWarningNotice(__('Some themes have not been delete.'));
+                } else {
+                    dcPage::addSuccessNotice(
+                        __('Theme has been successfully deleted.', 'Themes have been successuflly deleted.', $count)
+                    );
+                }
+                http::redirect($this->getURL());
+            } elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['install'])) {
+
+                if (is_array($_POST['install'])) {
+                    $modules = array_keys($_POST['install']);
+                }
+
+                $list = $this->store->get();
+
+                if (empty($list)) {
+                    throw new Exception(__('No such theme.'));
+                }
+
+                $count = 0;
+                foreach ($list as $id => $module) {
+
+                    if (!in_array($id, $modules)) {
+                        continue;
+                    }
+
+                    $dest = $this->getPath() . '/' . basename($module['file']);
+
+                    # --BEHAVIOR-- themeBeforeAdd
+                    $this->core->callBehavior('themeBeforeAdd', $module);
+
+                    $this->store->process($module['file'], $dest);
+
+                    # --BEHAVIOR-- themeAfterAdd
+                    $this->core->callBehavior('themeAfterAdd', $module);
+
+                    $count++;
+                }
+
+                dcPage::addSuccessNotice(
+                    __('Theme has been successfully installed.', 'Themes have been successuflly installed.', $count)
+                );
+                http::redirect($this->getURL());
+            } elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['update'])) {
+
+                if (is_array($_POST['update'])) {
+                    $modules = array_keys($_POST['update']);
+                }
+
+                $list = $this->store->get(true);
+                if (empty($list)) {
+                    throw new Exception(__('No such theme.'));
+                }
+
+                $count = 0;
+                foreach ($list as $module) {
+
+                    if (!in_array($module['id'], $modules)) {
+                        continue;
+                    }
+
+                    $dest = $module['root'] . '/../' . basename($module['file']);
+
+                    # --BEHAVIOR-- themeBeforeUpdate
+                    $this->core->callBehavior('themeBeforeUpdate', $module);
+
+                    $this->store->process($module['file'], $dest);
+
+                    # --BEHAVIOR-- themeAfterUpdate
+                    $this->core->callBehavior('themeAfterUpdate', $module);
+
+                    $count++;
+                }
+
+                $tab = $count && $count == count($list) ? '#themes' : '#update';
+
+                dcPage::addSuccessNotice(
+                    __('Theme has been successfully updated.', 'Themes have been successuflly updated.', $count)
+                );
+                http::redirect($this->getURL() . $tab);
+            }
+
+            # Manual actions
+            elseif (!empty($_POST['upload_pkg']) && !empty($_FILES['pkg_file'])
+                || !empty($_POST['fetch_pkg']) && !empty($_POST['pkg_url'])) {
+                if (empty($_POST['your_pwd']) || !$this->core->auth->checkPassword($_POST['your_pwd'])) {
+                    throw new Exception(__('Password verification failed'));
+                }
+
+                if (!empty($_POST['upload_pkg'])) {
+                    files::uploadStatus($_FILES['pkg_file']);
+
+                    $dest = $this->getPath() . '/' . $_FILES['pkg_file']['name'];
+                    if (!move_uploaded_file($_FILES['pkg_file']['tmp_name'], $dest)) {
+                        throw new Exception(__('Unable to move uploaded file.'));
+                    }
+                } else {
+                    $url  = urldecode($_POST['pkg_url']);
+                    $dest = $this->getPath() . '/' . basename($url);
+                    $this->store->download($url, $dest);
+                }
+
+                # --BEHAVIOR-- themeBeforeAdd
+                $this->core->callBehavior('themeBeforeAdd', null);
+
+                $ret_code = $this->store->install($dest);
+
+                # --BEHAVIOR-- themeAfterAdd
+                $this->core->callBehavior('themeAfterAdd', null);
+
+                dcPage::addSuccessNotice($ret_code == 2 ?
+                    __('Theme has been successfully updated.') :
+                    __('Theme has been successfully installed.')
+                );
+                http::redirect($this->getURL() . '#themes');
+            } else {
+
+                # --BEHAVIOR-- adminModulesListDoActions
+                $this->core->callBehavior('adminModulesListDoActions', $this, $modules, 'theme');
+
+            }
+        }
+
+        return;
+    }
 }
